import * as botframework_webchat_core from 'botframework-webchat-core';
import * as react from 'react';
import * as botframework_directlinejs from 'botframework-directlinejs';
import { DirectLine } from 'botframework-directlinejs';
import { WebSpeechPonyfill } from 'botframework-webchat-api';
import * as apiDecorator from 'botframework-webchat-api/decorator';
import 'botframework-webchat-component/internal';
import botframework_webchat_component__default from 'botframework-webchat-component';

type CreateDirectLineOptions = {
    botAgent?: string;
    conversationId?: string;
    conversationStartProperties?: any;
    domain?: string;
    fetch?: typeof window.fetch;
    pollingInterval?: number;
    secret?: string;
    streamUrl?: string;
    token?: string;
    watermark?: string;
    webSocket?: typeof WebSocket;
};
declare function createDirectLine$1({ botAgent, conversationId, conversationStartProperties, domain, fetch, pollingInterval, secret, streamUrl, token, watermark, webSocket }: CreateDirectLineOptions): DirectLine;

declare function createDirectLineAppServiceExtension$1({ botAgent, conversationId, domain, token }: {
    botAgent?: string;
    conversationId?: string;
    domain?: string;
    token: string;
}): Promise<any>;

declare function createBrowserWebSpeechPonyfillFactory(): () => WebSpeechPonyfill;

declare const renderWebChat: any;
declare const version: string;
declare const buildInfo: Readonly<{
    buildTool: string;
    moduleFormat: string;
    variant: "minimal";
    version: string;
}>;
declare const createDirectLine: (options: Omit<Parameters<typeof createDirectLine$1>[0], "botAgent">) => botframework_directlinejs.DirectLine;
declare const createDirectLineAppServiceExtension: (options: Omit<Parameters<typeof createDirectLineAppServiceExtension$1>[0], "botAgent">) => Promise<any>;

declare const decorator: Readonly<{
    WebChatDecorator: react.MemoExoticComponent<({ children }: Readonly<{
        readonly children?: react.ReactNode | undefined;
    }>) => react.JSX.Element>;
    ActivityDecorator: react.MemoExoticComponent<({ activity, children }: Readonly<{
        activity?: botframework_webchat_core.WebChatActivity;
        children?: react.ReactNode;
    }>) => react.JSX.Element>;
    DecoratorComposer: react.MemoExoticComponent<(props: Readonly<{
        children?: react.ReactNode | undefined;
        middleware?: readonly apiDecorator.DecoratorMiddleware[] | undefined;
    }>) => react.JSX.Element>;
}>;

export { createDirectLineAppServiceExtension$1 as a, createBrowserWebSpeechPonyfillFactory as b, createDirectLine$1 as c, decorator as d, buildInfo as e, createDirectLine as f, createDirectLineAppServiceExtension as g, renderWebChat as r, version as v };
